Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views-3.3.csproj	(revision 7548)
@@ -89,11 +89,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="ToolTipComboBox.cs">
-      <SubType>Component</SubType>
-    </Compile>
-    <Compile Include="ToolTipComboBox.Designer.cs">
-      <DependentUpon>ToolTipComboBox.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ToolTipRequiredEventArgs.cs" />
     <Compile Include="ProblemInstanceProviderView.cs">
       <SubType>UserControl</SubType>
@@ -139,7 +132,4 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="ToolTipComboBox.resx">
-      <DependentUpon>ToolTipComboBox.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="ProblemInstanceProviderView.resx">
       <DependentUpon>ProblemInstanceProviderView.cs</DependentUpon>
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.Designer.cs	(revision 7548)
@@ -45,4 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.loadButton = new System.Windows.Forms.Button();
       this.label2 = new System.Windows.Forms.Label();
@@ -50,4 +51,5 @@
       this.importButton = new System.Windows.Forms.Button();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.SuspendLayout();
       // 
@@ -55,7 +57,7 @@
       // 
       this.loadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.loadButton.Location = new System.Drawing.Point(451, -1);
+      this.loadButton.Location = new System.Drawing.Point(549, -1);
       this.loadButton.Name = "loadButton";
-      this.loadButton.Size = new System.Drawing.Size(75, 23);
+      this.loadButton.Size = new System.Drawing.Size(26, 23);
       this.loadButton.TabIndex = 6;
       this.loadButton.Text = "Load";
@@ -80,5 +82,5 @@
       this.instancesComboBox.Location = new System.Drawing.Point(54, 0);
       this.instancesComboBox.Name = "instancesComboBox";
-      this.instancesComboBox.Size = new System.Drawing.Size(391, 21);
+      this.instancesComboBox.Size = new System.Drawing.Size(489, 21);
       this.instancesComboBox.TabIndex = 7;
       this.instancesComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
@@ -87,7 +89,7 @@
       // 
       this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.importButton.Location = new System.Drawing.Point(532, -1);
+      this.importButton.Location = new System.Drawing.Point(581, -1);
       this.importButton.Name = "importButton";
-      this.importButton.Size = new System.Drawing.Size(75, 23);
+      this.importButton.Size = new System.Drawing.Size(26, 23);
       this.importButton.TabIndex = 6;
       this.importButton.Text = "Import";
@@ -122,4 +124,5 @@
     private System.Windows.Forms.Button importButton;
     private System.Windows.Forms.OpenFileDialog openFileDialog;
+    private System.Windows.Forms.ToolTip toolTip;
 
   }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemInstanceProviderView.cs	(revision 7548)
@@ -21,4 +21,5 @@
 
 using System;
+using System.IO;
 using System.Linq;
 using System.Windows.Forms;
@@ -40,5 +41,10 @@
     public ProblemInstanceProviderView() {
       InitializeComponent();
+      importButton.Text = String.Empty;
       importButton.Image = VSImageLibrary.Open;
+      toolTip.SetToolTip(importButton, "Import a " + GetProblemType() + " instance from file.");
+      loadButton.Text = String.Empty;
+      loadButton.Image = VSImageLibrary.Checkout;
+      toolTip.SetToolTip(loadButton, "Load the selected instance.");
     }
 
@@ -49,5 +55,5 @@
       } else {
         instancesComboBox.DisplayMember = "Name";
-        instancesComboBox.DataSource = Content.GetInstanceDescriptors().ToList();
+        instancesComboBox.DataSource = Content.GetDataDescriptors().ToList();
       }
     }
@@ -60,26 +66,27 @@
 
     private void loadButton_Click(object sender, EventArgs e) {
-      var descriptor = (IInstanceDescriptor)instancesComboBox.SelectedItem;
-      var instance = Content.LoadInstance(descriptor);
-      if (!Content.Consumer.LoadFrom(instance)) {
-        MessageBox.Show("This problem does not support loading the instance " + descriptor.Name + ".", "Cannot load instance");
+      var descriptor = (IDataDescriptor)instancesComboBox.SelectedItem;
+      var instance = Content.LoadData(descriptor);
+      try {
+        Content.Consumer.Load(instance);
+      } catch (Exception ex) {
+        MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", descriptor.Name, Environment.NewLine + ex.Message), "Cannot load instance");
       }
     }
 
     private void importButton_Click(object sender, EventArgs e) {
+      openFileDialog.FileName = GetProblemType() + " instance";
       if (openFileDialog.ShowDialog() == DialogResult.OK) {
         T instance = default(T);
         try {
-          instance = Content.LoadInstance(openFileDialog.FileName);
-        } catch {
-          MessageBox.Show("There was an error parsing the file.", "Error while parsing", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          instance = Content.LoadData(openFileDialog.FileName);
+        } catch (Exception ex) {
+          MessageBox.Show(String.Format("There was an error parsing the file: {0}", Environment.NewLine + ex.Message), "Error while parsing", MessageBoxButtons.OK, MessageBoxIcon.Error);
           return;
         }
         try {
-          if (!Content.Consumer.LoadFrom(instance)) {
-            MessageBox.Show("This problem does not support loading the instance in the file.", "Cannot load instance", MessageBoxButtons.OK, MessageBoxIcon.Error);
-          }
-        } catch {
-          MessageBox.Show("There was an error while importing the file.");
+          Content.Consumer.Load(instance);
+        } catch (Exception ex) {
+          MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", Path.GetFileName(openFileDialog.FileName), Environment.NewLine + ex.Message), "Cannot load instance");
         }
       }
@@ -91,4 +98,11 @@
         comboBox.Items.Clear();
     }
+
+    private string GetProblemType() {
+      string dataTypeName = typeof(T).Name.Split(new char[] { '.' }, StringSplitOptions.RemoveEmptyEntries).Last();
+      if (dataTypeName.EndsWith("Data"))
+        return dataTypeName.Substring(0, dataTypeName.Length - "Data".Length);
+      else return dataTypeName;
+    }
   }
 }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.Designer.cs	(revision 7548)
@@ -47,5 +47,6 @@
       this.label1 = new System.Windows.Forms.Label();
       this.problemInstanceProviderViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.problemInstanceProviderComboBox = new HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views.ToolTipComboBox();
+      this.problemInstanceProviderComboBox = new System.Windows.Forms.ComboBox();
+      this.libraryInfoButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
@@ -93,8 +94,8 @@
       this.problemInstanceProviderViewHost.Content = null;
       this.problemInstanceProviderViewHost.Enabled = false;
-      this.problemInstanceProviderViewHost.Location = new System.Drawing.Point(229, 5);
+      this.problemInstanceProviderViewHost.Location = new System.Drawing.Point(259, 5);
       this.problemInstanceProviderViewHost.Name = "problemInstanceProviderViewHost";
       this.problemInstanceProviderViewHost.ReadOnly = false;
-      this.problemInstanceProviderViewHost.Size = new System.Drawing.Size(421, 21);
+      this.problemInstanceProviderViewHost.Size = new System.Drawing.Size(391, 21);
       this.problemInstanceProviderViewHost.TabIndex = 6;
       this.problemInstanceProviderViewHost.ViewsLabelVisible = false;
@@ -103,16 +104,22 @@
       // problemInstanceProviderComboBox
       // 
-      this.problemInstanceProviderComboBox.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable;
       this.problemInstanceProviderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.problemInstanceProviderComboBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.problemInstanceProviderComboBox.FormattingEnabled = true;
       this.problemInstanceProviderComboBox.Location = new System.Drawing.Point(50, 5);
-      this.problemInstanceProviderComboBox.MaxDropDownItems = 16;
       this.problemInstanceProviderComboBox.Name = "problemInstanceProviderComboBox";
-      this.problemInstanceProviderComboBox.Size = new System.Drawing.Size(173, 21);
+      this.problemInstanceProviderComboBox.Size = new System.Drawing.Size(171, 21);
       this.problemInstanceProviderComboBox.TabIndex = 7;
-      this.problemInstanceProviderComboBox.ToolTipRequired += new System.EventHandler<HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views.ToolTipRequiredEventArgs>(this.problemInstanceProviderComboBox_ToolTipRequired);
       this.problemInstanceProviderComboBox.SelectedIndexChanged += new System.EventHandler(this.problemInstanceProviderComboBox_SelectedIndexChanged);
       this.problemInstanceProviderComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
+      // 
+      // libraryInfoButton
+      // 
+      this.libraryInfoButton.Location = new System.Drawing.Point(227, 4);
+      this.libraryInfoButton.Name = "libraryInfoButton";
+      this.libraryInfoButton.Size = new System.Drawing.Size(26, 23);
+      this.libraryInfoButton.TabIndex = 8;
+      this.libraryInfoButton.Text = "Info";
+      this.libraryInfoButton.UseVisualStyleBackColor = true;
+      this.libraryInfoButton.Click += new System.EventHandler(this.libraryInfoButton_Click);
       // 
       // ProblemView
@@ -123,12 +130,14 @@
       this.Controls.Add(this.problemInstanceProviderComboBox);
       this.Controls.Add(this.label1);
+      this.Controls.Add(this.libraryInfoButton);
       this.Name = "ProblemView";
       this.Size = new System.Drawing.Size(653, 455);
+      this.Controls.SetChildIndex(this.libraryInfoButton, 0);
+      this.Controls.SetChildIndex(this.label1, 0);
+      this.Controls.SetChildIndex(this.problemInstanceProviderComboBox, 0);
+      this.Controls.SetChildIndex(this.problemInstanceProviderViewHost, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.label1, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
-      this.Controls.SetChildIndex(this.problemInstanceProviderComboBox, 0);
-      this.Controls.SetChildIndex(this.problemInstanceProviderViewHost, 0);
       this.Controls.SetChildIndex(this.parameterCollectionView, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
@@ -142,5 +151,6 @@
     private System.Windows.Forms.Label label1;
     private MainForm.WindowsForms.ViewHost problemInstanceProviderViewHost;
-    private ToolTipComboBox problemInstanceProviderComboBox;
+    private System.Windows.Forms.ComboBox problemInstanceProviderComboBox;
+    private System.Windows.Forms.Button libraryInfoButton;
 
   }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/ProblemView.cs	(revision 7548)
@@ -22,7 +22,9 @@
 using System;
 using System.Collections.Generic;
+using System.Diagnostics;
 using System.Linq;
 using System.Reflection;
 using System.Windows.Forms;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
@@ -42,6 +44,12 @@
     }
 
+    private IProblemInstanceProvider SelectedProvider {
+      get { return (problemInstanceProviderComboBox.SelectedIndex >= 0 ? (IProblemInstanceProvider)problemInstanceProviderComboBox.SelectedItem : null); }
+    }
+
     public ProblemView() {
       InitializeComponent();
+      libraryInfoButton.Text = String.Empty;
+      libraryInfoButton.Image = VSImageLibrary.Information;
     }
 
@@ -54,25 +62,27 @@
         problemInstanceProviderComboBox.DataSource = GetProblemInstanceProviders().ToList();
       }
+      SetEnabledStateOfControls();
     }
 
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      problemInstanceProviderComboBox.Enabled = !ReadOnly && !Locked && Content != null;
+      problemInstanceProviderComboBox.Enabled = !ReadOnly && !Locked && Content != null && problemInstanceProviderComboBox.Items.Count > 0;
+      libraryInfoButton.Enabled = SelectedProvider != null && SelectedProvider.WebLink != null;
     }
 
     private void problemInstanceProviderComboBox_SelectedIndexChanged(object sender, System.EventArgs e) {
       if (problemInstanceProviderComboBox.SelectedIndex >= 0) {
-        var provider = (IProblemInstanceProvider)problemInstanceProviderComboBox.SelectedItem;
-        var genericType = provider.GetType().GetInterfaces().Single(x => x.IsGenericType && x.GetGenericTypeDefinition() == typeof(IProblemInstanceProvider<>)).GetGenericArguments().First();
+        var genericType = SelectedProvider.GetType().GetInterfaces().Single(x => x.IsGenericType && x.GetGenericTypeDefinition() == typeof(IProblemInstanceProvider<>)).GetGenericArguments().First();
         this.GetType().GetMethod("SetConsumable", BindingFlags.NonPublic | BindingFlags.Instance)
-          .MakeGenericMethod(genericType).Invoke(this, new object[] { provider, Content });
-        problemInstanceProviderViewHost.Content = provider;
+          .MakeGenericMethod(genericType).Invoke(this, new object[] { SelectedProvider, Content });
+        problemInstanceProviderViewHost.Content = SelectedProvider;
+        SetTooltip();
       }
+      SetEnabledStateOfControls();
     }
 
-    /// <summary>
-    /// Do not change method name without changing the string reference above
-    /// </summary>
-    private void SetConsumable<T>(IProblemInstanceProvider<T> producer, IConsumable<T> consumer) {
+    // Do not change method without changing the reflection call above
+    [Obsolete]
+    private void SetConsumable<T>(IProblemInstanceProvider<T> producer, IProblemInstanceConsumer<T> consumer) {
       producer.Consumer = consumer;
     }
@@ -84,8 +94,15 @@
     }
 
+    private void libraryInfoButton_Click(object sender, EventArgs e) {
+      if (problemInstanceProviderComboBox.SelectedIndex >= 0) {
+        if (SelectedProvider != null && SelectedProvider.WebLink != null)
+          Process.Start(SelectedProvider.WebLink.ToString());
+      }
+    }
+
     protected virtual IEnumerable<IProblemInstanceProvider> GetProblemInstanceProviders() {
       var consumerTypes = Content.GetType().GetInterfaces()
         .Where(x => x.IsGenericType
-          && x.GetGenericTypeDefinition() == typeof(IConsumable<>));
+          && x.GetGenericTypeDefinition() == typeof(IProblemInstanceConsumer<>));
 
       if (consumerTypes.Any()) {
@@ -101,20 +118,27 @@
     }
 
-    protected virtual string GetProviderToolTip(IProblemInstanceProvider provider) {
-      if (provider.WebLink != null) {
-        return provider.Name
-            + Environment.NewLine
-            + provider.WebLink.ToString()
-            + Environment.NewLine + Environment.NewLine
-            + provider.ReferencePublication;
-      } else {
-        return provider.Name
+    private void SetTooltip() {
+      toolTip.SetToolTip(problemInstanceProviderComboBox, GetProviderToolTip());
+      if (SelectedProvider.WebLink != null)
+        toolTip.SetToolTip(libraryInfoButton, "Browse to " + SelectedProvider.WebLink.ToString());
+      else toolTip.SetToolTip(libraryInfoButton, "Library does not have a web reference.");
+    }
+
+    protected virtual string GetProviderToolTip() {
+      var provider = SelectedProvider;
+      string toolTip = provider.Name;
+
+      if (!String.IsNullOrEmpty(provider.ReferencePublication)) {
+        toolTip = toolTip
             + Environment.NewLine + Environment.NewLine
             + provider.ReferencePublication;
       }
-    }
+      if (provider.WebLink != null) {
+        toolTip = toolTip
+            + Environment.NewLine
+            + provider.WebLink.ToString();
+      }
 
-    private void problemInstanceProviderComboBox_ToolTipRequired(object sender, ToolTipRequiredEventArgs e) {
-      e.ToolTip = GetProviderToolTip((IProblemInstanceProvider)e.Item);
+      return toolTip;
     }
   }
